using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections.Specialized;
using System.Collections;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Drawing;
using Syncfusion.Styles;
using Syncfusion.Windows.Forms;

namespace GGC_Nested
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
    private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
      ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
      this.SuspendLayout();
      // 
      // gridGroupingControl1
      // 
      this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                  | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
      this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
      this.gridGroupingControl1.Name = "gridGroupingControl1";
      this.gridGroupingControl1.Size = new System.Drawing.Size(499, 358);
      this.gridGroupingControl1.TabIndex = 0;
      this.gridGroupingControl1.Text = "gridGroupingControl1";
      this.gridGroupingControl1.VersionInfo = "3.301.0.0";
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(510, 369);
      this.Controls.Add(this.gridGroupingControl1);
      this.Name = "Form1";
      this.Text = "GGC_Font";
      this.Load += new System.EventHandler(this.Form1_Load);
      ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
      this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());			
		}

    #region * DataSource *

    private int numberParentRows = 5;
    private int numberChildRows = 50;

    private DataTable GetParentTable()
    {
      DataTable dt = new DataTable("ParentTable");
      Random r = new Random();

      dt.Columns.Add(new DataColumn("parentID")); //lower case p
      dt.Columns.Add(new DataColumn("ParentName"));
      dt.Columns.Add(new DataColumn("ParentDesc"));
      dt.Columns.Add(new DataColumn("Check", typeof(bool)));

      for (int i = 0; i < numberParentRows; ++i)
      {
        DataRow dr = dt.NewRow();
        dr[0] = i;//.ToString();
        dr[1] = string.Format("parentName{0}", i);
        dr[2] = string.Format("desc{0}", i);
        dr[3] = r.Next(2) == 1 ? true : false;
        dt.Rows.Add(dr);
      }

      return dt;
    }

    private DataTable GetChildTable()
    {
      DataTable dt = new DataTable("ChildTable");
      Random r = new Random();

      dt.Columns.Add(new DataColumn("childID")); //lower case c
      dt.Columns.Add(new DataColumn("Name"));
      dt.Columns.Add(new DataColumn("ParentID")); //upper case P

      dt.Columns.Add(new DataColumn("ChildCheck", typeof(bool)));


      for (int i = 0; i < numberChildRows; ++i)
      {
        DataRow dr = dt.NewRow();
        dr[0] = i.ToString();
        dr[1] = string.Format("ChildName{0}", i);
        dr[2] = (i % (numberParentRows)).ToString();
        dr[3] = r.Next(2) == 1 ? true : false;
        dt.Rows.Add(dr);
      }

      return dt;
    }

    #endregion

    DataSet ds;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
			 
			ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});

			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			
			ds.Relations.AddRange(new DataRelation[]{parentToChild });
			
			this.gridGroupingControl1.DataSource = parentTable;
			
			this.gridGroupingControl1.NestedTableGroupOptions.ShowCaption = false;
      this.gridGroupingControl1.TableDescriptor.AllowNew = false;
      this.gridGroupingControl1.ShowGroupDropArea = true;

      this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

      this.gridGroupingControl1.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(gridGroupingControl1_SaveCellText);
      this.gridGroupingControl1.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
      this.gridGroupingControl1.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp);
      this.gridGroupingControl1.TableControlCheckBoxClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);
		}

    bool CheckBoxValue = true;
    void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
    {
        if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell &&
          e.TableCellIdentity.Column.Name == "Check")
        {
          e.Style.CellType = "CheckBox";
          e.Style.ReadOnly = false;
          e.Style.CellAppearance = GridCellAppearance.Raised;
          e.Style.CellValue = CheckBoxValue;
          e.Style.CellValueType = typeof(bool);
          e.Style.Enabled = true;
        }
        e.Handled = true;
    }

    void gridGroupingControl1_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
    {
      GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
      if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
      {
        this.CheckBoxValue = bool.Parse(e.Text);
        e.Handled = true;
      }
    }

    void gridGroupingControl1_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
    {
      GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex];
      if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && style.TableCellIdentity.Column.Name == "Check")
      {
        e.Inner.Cancel = true;
      }
    }

    void TableControl_MouseUp(object sender, MouseEventArgs e)
    {
      int row, col;
      this.gridGroupingControl1.TableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
      GridTableCellStyleInfo style = this.gridGroupingControl1.TableControl.Model[row, col];
      IMouseController controller;
      this.gridGroupingControl1.TableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

      if (controller != null && controller.Name == "DragGroupHeader")
      {
        this.gridGroupingControl1.TableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
      }
    }

    void gridGroupingControl1_TableControlCheckBoxClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
    {
      Console.WriteLine("CheckBoxClicked");
      GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
      if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
      {
        bool chk = (bool)this.gridGroupingControl1.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue;
        e.TableControl.BeginUpdate();
        foreach (Record rec in e.TableControl.Table.Records)
          rec.SetValue("Check", !chk);
        e.TableControl.EndUpdate(true);
      }
    }

	}
}
